clear;
clc;
elvalasztas = '#################################################################################';


disp('NV:         ');
disp('Neptun Kd:  ');

disp(' ');
disp('4.');
disp(' ');

disp('A szablyozsi kr tviteli fggvnyei:');
disp('Wc:'); Wc = tf([15 1],[15 0]);
T=evalc('Wc'); disp(T(22:end));
disp('Wp:'); Wp = tf([2], conv(conv([2 1], [2 1]),[15 1]));
T=evalc('Wp'); disp(T(22:end));

disp('Enter a folytatshoz...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('1. rja fel a nyitott kr tviteli fggvnyt!');
disp('W0 = Wc*Wp = ');
W0 = Wc*Wp;
T=evalc('W0'); disp(T(22:end));

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('2. Rajzolja meg az alaptagok alkalmazsval a zrt rendszer hatsvzlatt!');
disp('- Zrt rendszer tviteli fggvnye:');
disp('W = W0 / (1 + W0)');
W = feedback(W0, 1, -1); %1 = merev visszacsatols, -1 = negatv visszacsatols) --> W = W/(1+W)
                         %W = zrt rendszer tviteli fggvnye
T=evalc('W'); disp(T(22:end));

disp('- llapotvltozs lers norml alakja:');
[num, den] = tfdata(W);
num = num{1};
den = den{1};
[A,B,C,D]=tf2ss(num,den)
disp('- Ebbl kzvetlenl felrhat a hatsvzlat:   Enter...');
pause;
open_system('hazi_feladat_modell');

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('3. rja fel az llapotegyenlet rendszert!');
disp('- Az llapotvltozs lersbl kzvetlenl felrhat:');
%dx1(t)/dt=(-4/3)*x1(t)+(-7/12)*x2(t)+(-1/30)*x4(t)+(1)*u(t);
%dx2(t)/dt=(1)*x1(t)+(0)*x2(t)+(0)*x3(t)+(0)*x4(t)+(0)*u(t);
%...
%y(t)=(0)*x1(t)+(0)*x2(t)+(0.1667)*x3(t)+(0.0333)*x4(t)+(0)*u(t)

sor = '';
for i=1:1:length(A(:,1)) %sorok
    sor=['x' num2str(i) '(t)/dt='];
    for j=1:1:length(A(i,:)) %elemek a sorokban (oszlopok)
        sor=[sor '(' num2str(A(i,j)) ')*x' num2str(j) '(t)+'];
    end
    sor=[sor '(' num2str(B(i)) ')*u(t)'];
    disp(sor);
end

sor='y(t)=';
for i=1:1:length(C)
    sor=[sor '(' num2str(C(i)) ')*x' num2str(i) '(t)+'];
end
sor=[sor '(' num2str(D) ')*u(t)'];
disp(sor);

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('4. Vizsglja meg, stabilis-e a rendszer! Adja meg a sajtrtkek sszegt!');
disp('- Stabilis a rendszer, ha a rendszermtrix sajtrtkeinek vals rsze negatv.');
disp('- Sajtrtkek:'); la = eig(A); disp(la);
disp('- Minden sajtrtk negatv vals rsszel rendelkezik, ezrt a rendszer stabilis.');
disp('');
disp('- Sajtrtkek sszege:')
sumla = 0;
for i=1:1:length(la)
    sumla = sumla + la(i);
end
disp(sumla); %A sajtrtkek sszege teht -4/3.

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('5. Mennyi a rendszer tpusszma?');
disp('- Tpussszm = a nulla gykk szma az tviteli fggvny nevezjben.')
disp('- Gykk:')
disp(roots(W.den{1}));
disp('- Az tviteli fggvny plusai megegyeznek a sajtrtkekkel.');
disp('- Mivel nincsen 0 plus, ezrt a rendszer tpusszma 0. (i=0)');
disp('- Teht a rendszer egy nbell stabilis tag, 0 tpus, arnyos szablyozs.');

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('6. Hatrozzuk meg a rendszer slyfggvnyeit!');
disp('- A gerjesztjel a Dirac-impulzus. Ennek a Laplace-transzformltja 1, ezrt nem vltozik az tviteli fggvny.');
disp('- Az tviteli fggvnyt parcilis trtekre bontjuk:');
[num, den] = tfdata(W);
num = num{1};
den = den{1};
[r,p,k]=residue(num,den)
disp('- A felbontott tviteli fggvny rszei ilyen alakak:');
disp('   r');
disp(' -----');
disp(' s - p');
disp(' ');

%Trtek sszegnek kirajzolsa:
warning('off','all');   %a komplex szmok nem tetszenek neki
sor1 = '        ';
sor2 = 'W(s) =  ';
sor3 = '        ';
for i = 1:1:length(r)
    TF=tf(r(i), [1 -p(i)]);
    T=evalc('TF');
    k = 1; ures = 0;
    for j = 22:1:length(T)
        if T(j)==sprintf('\n')
            k=k+1;
        else
            switch k
                case 1
                    sor1 = [sor1 T(j)];
                case 2
                     sor2 = [sor2 T(j)];
                case 3
                    sor3 = [sor3 T(j)];
            end
        end
    end
   
   if i~=length(r)
     sor1 = [sor1 '       '];
     sor2 = [sor2 '  +  '];
     sor3 = [sor3 '     '];
   end
end
disp(sor1);
disp(sor2);
disp(sor3);
warning('on','all')

disp(' ');
disp('- Ebbl a slyfggvny inverz Laplace-transzformlssal:');
sor = '';
for i=1:1:length(r)
    %r(i)*exp(p(i)*t)
    if i~=length(r)
        sor = [sor '(' num2str(r(i)) ')*exp((' num2str(p(i)) ')*t)+'];
    else
        sor = [sor '(' num2str(r(i)) ')*exp((' num2str(p(i)) ')*t)'];
    end
end
disp(['w(t)=' sor]);

%kirajzols:
figure(1);
t = 0:1:70;
plot(t,eval(sor));
title('Slyfggvny');
xlabel('id: t');
ylabel('amplitd: w(t)');

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('7. Adjuk meg a rendszer tmeneti fggvnyeit, s szmtsuk ki az y kimen jel y(inf) vgrtkt!');
disp('- tmeneti fggvny = egysgugrs gerjesztsre adott vlasz.');
disp('- tmeneti fggvny = a slyfggvnynek az integrlja.');

%1. tag integrlja: r(1)/p(1)*(exp(p(1)*t)-1)
sor='';
for i=1:1:length(r)
    %sor = [sor '(' num2str(r(i)) ')/(' num2str(p(i)) ')*(exp((' num2str(p(i)) ')*t)-1)'];
    sor = [sor '(' num2str(r(i)/p(i)) ')*(exp((' num2str(p(i)) ')*t)-1)'];
    if i~=length(r)
        sor = [sor '+'];
    end
end
disp(['v(t)=' sor]);

figure(2);
t = 0:1:70;
plot(t,eval(sor));
title('tmeneti fggvny');
xlabel('id: t');
ylabel('amplutd: v(t)');

disp('- Az tmeneti fggvny vgrtke 1.')
%disp('- Ezt az elzbl is kiderthettk, mert az impulzusvlasz vgrtke 0, gy a kimeneti jel a kezdeti tranziensek lezajlsa utn kveti a bemen jelet.');
disp('- Msik megolds:');
W;
disp('- Az tviteli fggvnybe s=0-t helyettestve megkapjuk, hogy W(s=0)=2/2=1. Ez a vgrtk.');

%Ellenrzs:
%step(A,B,C,D);
%disp('Az llandsult rtk a v(t)= 1 -hez tart.');

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('8. Szmtsuk ki a rendszer tviteli mtrixt!');
disp('- SISO rendszer esetn az tviteli mtrix egyetlen elemet tartalmaz, az tviteli fggvnyt.')
Wm = [W];
disp('Wm:');
T=evalc('Wm'); disp(T(22:end));

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('9. Adjuk meg a fzistartalkot, az amplitd tartalkot s a vgsi krfrekvencit.');
[Gm,Pm,Wgm,Wpm] = margin(W);
disp(['- Fzistartalk:      ' num2str(Pm) '']);
disp(['- Amplitd-tartalk: ' num2str(20*log10(Gm)) ' dB']);
disp(['- Vgsi frekvencia:  ' num2str(Wpm) ' rad/s']);
figure(3);
margin(W);

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('10. Hasonltsuk ssze a nyitott s a zrt kt amplitd meneteit!');
figure(4);
title('Nyitott s zrt kr amplitd menetnek sszehasonltsa');
hold on;
bodemag(W0);
bodemag(W);
legend('nylt (W0)','zrt(W)')
hold off;
disp('- A 4. brn lthat, hogy a zrt kr esetn az tvitel a vgsi frekvenciig konstans 1 (vagyis 0 dB), mg nylt krnl az amplitd folyamatosan cskken.');

disp('Enter...');
disp(elvalasztas);
pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp('11. brzoljuk a zrt kr tmeneti fggvnyt.');
figure(5);
step(W);
disp('- Kb. 50 idegysgig lengedezik, utna bell a kimenet a gerjesztjel rtkre.');

%disp('Enter a kilpshez...');
%pause;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%close all;
%close_system;
%clear;
%clc;